/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the MessageContactName type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MessageContactName{}

// MessageContactName struct for MessageContactName
type MessageContactName struct {
	FormattedName *string `json:"formatted_name,omitempty"`
	FirstName *string `json:"first_name,omitempty"`
	LastName *string `json:"last_name,omitempty"`
	AdditionalName *string `json:"additional_name,omitempty"`
	Prefix *string `json:"prefix,omitempty"`
	Suffix *string `json:"suffix,omitempty"`
}

// NewMessageContactName instantiates a new MessageContactName object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMessageContactName() *MessageContactName {
	this := MessageContactName{}
	return &this
}

// NewMessageContactNameWithDefaults instantiates a new MessageContactName object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMessageContactNameWithDefaults() *MessageContactName {
	this := MessageContactName{}
	return &this
}

// GetFormattedName returns the FormattedName field value if set, zero value otherwise.
func (o *MessageContactName) GetFormattedName() string {
	if o == nil || IsNil(o.FormattedName) {
		var ret string
		return ret
	}
	return *o.FormattedName
}

// GetFormattedNameOk returns a tuple with the FormattedName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContactName) GetFormattedNameOk() (*string, bool) {
	if o == nil || IsNil(o.FormattedName) {
		return nil, false
	}
	return o.FormattedName, true
}

// HasFormattedName returns a boolean if a field has been set.
func (o *MessageContactName) HasFormattedName() bool {
	if o != nil && !IsNil(o.FormattedName) {
		return true
	}

	return false
}

// SetFormattedName gets a reference to the given string and assigns it to the FormattedName field.
func (o *MessageContactName) SetFormattedName(v string) {
	o.FormattedName = &v
}

// GetFirstName returns the FirstName field value if set, zero value otherwise.
func (o *MessageContactName) GetFirstName() string {
	if o == nil || IsNil(o.FirstName) {
		var ret string
		return ret
	}
	return *o.FirstName
}

// GetFirstNameOk returns a tuple with the FirstName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContactName) GetFirstNameOk() (*string, bool) {
	if o == nil || IsNil(o.FirstName) {
		return nil, false
	}
	return o.FirstName, true
}

// HasFirstName returns a boolean if a field has been set.
func (o *MessageContactName) HasFirstName() bool {
	if o != nil && !IsNil(o.FirstName) {
		return true
	}

	return false
}

// SetFirstName gets a reference to the given string and assigns it to the FirstName field.
func (o *MessageContactName) SetFirstName(v string) {
	o.FirstName = &v
}

// GetLastName returns the LastName field value if set, zero value otherwise.
func (o *MessageContactName) GetLastName() string {
	if o == nil || IsNil(o.LastName) {
		var ret string
		return ret
	}
	return *o.LastName
}

// GetLastNameOk returns a tuple with the LastName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContactName) GetLastNameOk() (*string, bool) {
	if o == nil || IsNil(o.LastName) {
		return nil, false
	}
	return o.LastName, true
}

// HasLastName returns a boolean if a field has been set.
func (o *MessageContactName) HasLastName() bool {
	if o != nil && !IsNil(o.LastName) {
		return true
	}

	return false
}

// SetLastName gets a reference to the given string and assigns it to the LastName field.
func (o *MessageContactName) SetLastName(v string) {
	o.LastName = &v
}

// GetAdditionalName returns the AdditionalName field value if set, zero value otherwise.
func (o *MessageContactName) GetAdditionalName() string {
	if o == nil || IsNil(o.AdditionalName) {
		var ret string
		return ret
	}
	return *o.AdditionalName
}

// GetAdditionalNameOk returns a tuple with the AdditionalName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContactName) GetAdditionalNameOk() (*string, bool) {
	if o == nil || IsNil(o.AdditionalName) {
		return nil, false
	}
	return o.AdditionalName, true
}

// HasAdditionalName returns a boolean if a field has been set.
func (o *MessageContactName) HasAdditionalName() bool {
	if o != nil && !IsNil(o.AdditionalName) {
		return true
	}

	return false
}

// SetAdditionalName gets a reference to the given string and assigns it to the AdditionalName field.
func (o *MessageContactName) SetAdditionalName(v string) {
	o.AdditionalName = &v
}

// GetPrefix returns the Prefix field value if set, zero value otherwise.
func (o *MessageContactName) GetPrefix() string {
	if o == nil || IsNil(o.Prefix) {
		var ret string
		return ret
	}
	return *o.Prefix
}

// GetPrefixOk returns a tuple with the Prefix field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContactName) GetPrefixOk() (*string, bool) {
	if o == nil || IsNil(o.Prefix) {
		return nil, false
	}
	return o.Prefix, true
}

// HasPrefix returns a boolean if a field has been set.
func (o *MessageContactName) HasPrefix() bool {
	if o != nil && !IsNil(o.Prefix) {
		return true
	}

	return false
}

// SetPrefix gets a reference to the given string and assigns it to the Prefix field.
func (o *MessageContactName) SetPrefix(v string) {
	o.Prefix = &v
}

// GetSuffix returns the Suffix field value if set, zero value otherwise.
func (o *MessageContactName) GetSuffix() string {
	if o == nil || IsNil(o.Suffix) {
		var ret string
		return ret
	}
	return *o.Suffix
}

// GetSuffixOk returns a tuple with the Suffix field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContactName) GetSuffixOk() (*string, bool) {
	if o == nil || IsNil(o.Suffix) {
		return nil, false
	}
	return o.Suffix, true
}

// HasSuffix returns a boolean if a field has been set.
func (o *MessageContactName) HasSuffix() bool {
	if o != nil && !IsNil(o.Suffix) {
		return true
	}

	return false
}

// SetSuffix gets a reference to the given string and assigns it to the Suffix field.
func (o *MessageContactName) SetSuffix(v string) {
	o.Suffix = &v
}

func (o MessageContactName) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MessageContactName) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.FormattedName) {
		toSerialize["formatted_name"] = o.FormattedName
	}
	if !IsNil(o.FirstName) {
		toSerialize["first_name"] = o.FirstName
	}
	if !IsNil(o.LastName) {
		toSerialize["last_name"] = o.LastName
	}
	if !IsNil(o.AdditionalName) {
		toSerialize["additional_name"] = o.AdditionalName
	}
	if !IsNil(o.Prefix) {
		toSerialize["prefix"] = o.Prefix
	}
	if !IsNil(o.Suffix) {
		toSerialize["suffix"] = o.Suffix
	}
	return toSerialize, nil
}

type NullableMessageContactName struct {
	value *MessageContactName
	isSet bool
}

func (v NullableMessageContactName) Get() *MessageContactName {
	return v.value
}

func (v *NullableMessageContactName) Set(val *MessageContactName) {
	v.value = val
	v.isSet = true
}

func (v NullableMessageContactName) IsSet() bool {
	return v.isSet
}

func (v *NullableMessageContactName) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessageContactName(val *MessageContactName) *NullableMessageContactName {
	return &NullableMessageContactName{value: val, isSet: true}
}

func (v NullableMessageContactName) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessageContactName) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


